# Showcases

## Apps
### Hekla for Hacker News

A hacker news client built from the ground up with v2 of react-native-navigation. 

It is a tab-based app and utilizes Split Layout for iOS tablets, 3D touch and more.

- [Source code](https://github.com/birkir/hekla)
- [Download iOS](https://itunes.apple.com/us/app/hekla/id1405096983?mt=8)
- [Download Android](https://play.google.com/store/apps/details?id=is.pipe.hekla)

## Starter Kits
* [atoami/react-native-navigation-redux-starter-kit](https://github.com/atoami/react-native-navigation-redux-starter-kit) - React Native Navigation(v2) Starter Kit with Redux, Saga, ESLint, Babel and Jest 😎
* [alexwasner/react-native-mobx-firebase-starter](https://github.com/alexwasner/react-native-mobx-firebase-starter) - A React Native starter app with React Native Navigation(v2), MobX, Firebase, Lottie and More 🤓
* [kanzitelli/react-native-navigation-starter](https://github.com/kanzitelli/react-native-navigation-starter) - Simple yet practical starter with React Native Navigation (**v3**), [Redux](https://github.com/reduxjs/redux) and more goodies such as Typescript, [RNN Hooks](https://github.com/underscopeio/react-native-navigation-hooks), [RN Vector Icons](https://github.com/oblador/react-native-vector-icons), [RN Gesture Handler](https://github.com/kmagiera/react-native-gesture-handler), [Redux Saga](https://github.com/redux-saga/redux-saga) and [Persist](https://github.com/rt2zz/redux-persist). As an example, basic Reddit App implemented inside.

### Playground

The playground example is a place where we showcase and test all features of react-native-navigation.

```bash
git clone https://github.com/wix/react-native-navigation
cd react-native-navigation
npm install

# for iOS:
npm run xcode # Opens XCode
npm start # Starts the packager on linux like systems

# for Android:
# 1. open Android Studio inside ".\playground"
# 2. start a emulator
npm run start-windows # Start the packager if you are on a windows system

# Run the app in Simulator or on Device from within XCode/Android Studio
```
